#include "symtables.hh"

hash_map<std::string, UserType> TypeMap;

bool TypeInfo::operator==(const TypeInfo& b) const
{
    return Type==b.Type
        && dynamic==b.dynamic
        && fixlength==b.fixlength
        && dimensions==b.dimensions
        && !members==!b.members
        && (!members || *members == *b.members)
      ;
}

bool UserType::operator==(const UserType& b)const
{
    for(unsigned a=0; a<size(); ++a)
        if( (*this)[a].first   != b[a].first
        || !(*this)[a].second  != !b[a].second
        || (b[a].second && *(*this)[a].second != *b[a].second)
          )
            return false;
     
     return Names == b.Names;
}

bool UserType::DeclareMember(const std::string& name, TypeP p)
{
    if(Names.find(name) != Names.end()) return false;
    Names.insert(name);
    (*this).push_back(std::make_pair(name, p));
    return true;
}
